#ifndef _COM_SUN_STAR_DEPLOYMENT_LICENSEEXCEPTION_HPP_
#define _COM_SUN_STAR_DEPLOYMENT_LICENSEEXCEPTION_HPP_

#ifndef _SAL_CONFIG_H_
#include "sal/config.h"
#endif

#ifndef _COM_SUN_STAR_DEPLOYMENT_LICENSEEXCEPTION_HDL_
#include "com/sun/star/deployment/LicenseException.hdl"
#endif

#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include "com/sun/star/uno/Exception.hpp"
#endif
#ifndef _COM_SUN_STAR_UNO_TYPE_HXX_
#include "com/sun/star/uno/Type.hxx"
#endif
#ifndef INCLUDED_CPPU_UNOTYPE_HXX
#include "cppu/unotype.hxx"
#endif
#ifndef _OSL_MUTEX_HXX_
#include "osl/mutex.hxx"
#endif
#ifndef _RTL_USTRING_HXX_
#include "rtl/ustring.hxx"
#endif
#ifndef _SAL_TYPES_H_
#include "sal/types.h"
#endif

namespace com { namespace sun { namespace star { namespace deployment {

inline LicenseException::LicenseException() SAL_THROW( () )
    : ::com::sun::star::uno::Exception()
    , ExtensionName()
    , Text()
    , IndividualAgreement(false)
{ }

inline LicenseException::LicenseException(const ::rtl::OUString& Message_, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Context_, const ::rtl::OUString& ExtensionName_, const ::rtl::OUString& Text_, const ::sal_Bool& IndividualAgreement_) SAL_THROW( () )
    : ::com::sun::star::uno::Exception(Message_, Context_)
    , ExtensionName(ExtensionName_)
    , Text(Text_)
    , IndividualAgreement(IndividualAgreement_)
{ }

LicenseException::LicenseException(LicenseException const & the_other): ::com::sun::star::uno::Exception(the_other), ExtensionName(the_other.ExtensionName), Text(the_other.Text), IndividualAgreement(the_other.IndividualAgreement) {}

LicenseException::~LicenseException() {}

LicenseException & LicenseException::operator =(LicenseException const & the_other) {
    //TODO: Just like its implicitly-defined counterpart, this function definition is not exception-safe
    ::com::sun::star::uno::Exception::operator =(the_other);
    ExtensionName = the_other.ExtensionName;
    Text = the_other.Text;
    IndividualAgreement = the_other.IndividualAgreement;
    return *this;
}

} } } }

namespace com { namespace sun { namespace star { namespace deployment {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::deployment::LicenseException const *) {
    static typelib_TypeDescriptionReference * the_type = 0;
    if ( !the_type )
    {
        typelib_static_type_init( &the_type, typelib_TypeClass_EXCEPTION, "com.sun.star.deployment.LicenseException" );
    }
    return * reinterpret_cast< ::com::sun::star::uno::Type * >( &the_type );
};

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::deployment::LicenseException const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::deployment::LicenseException >::get();
}

#endif // _COM_SUN_STAR_DEPLOYMENT_LICENSEEXCEPTION_HPP_
